itpp::BERC Class Reference

Bit Error Rate Counter (BERC) Class. More...

`#include <itpp/comm/error_counters.h>`

## Public Member Functions

| BERC (int indelay=0, int inignorefirst=0, int inignorelast=0)
| Constructor for the berc class. More...
void | count (const bvec &in1, const bvec &in2)
| Cumulative error counter.
void | count (const bool x)
| Variant of the cumulative error counter. Counts a bit error if x is true, and a correct bit otherwise.
void | estimate_delay (const bvec &in1, const bvec &in2, int mindelay=-100, int maxdelay=100)
| Run this member function if the delay between in1 and in2 is unknown.
void | clear ()
| Clears the bit error counter.
void | report () const
| Writes an error report.
int | get_delay () const
| Return the delay, assumed or estimated, between in1 and in2.
double | get_errors () const
| Returns the counted number of bit errors.
double | get_corrects () const
| Returns the counted number of corectly received bits.
double | get_total_bits () const
| Returns the total number of bits processed.
double | get_errorrate () const
| Returns the estimated bit error rate.

## Static Public Member Functions

static double | count_errors (const bvec &in1, const bvec &in2, int indelay=0, int inignorefirst=0, int inignorelast=0)
| static function to allow simple and fast count of bit-errors More...

## Detailed Description

Bit Error Rate Counter (BERC) Class.

Example:

#include <itpp/itcomm.h>
int main() {
//Initiate the Bit Error Counter
BERC berc;
//Initiate a Binary Symetric Channel with cross-over probability 0.1
BSC binary_symetric_channel(0.1);
bvec transmitted_bits = randb(100);
bvec received_bits = binary_symetric_channel(transmitted_bits);
//Count the number of bit errors
berc.count(transmitted_bits, received_bits);
cout << "Estimated bit error probability is " << berc.get_errorrate()
<< endl;
return 0;
}

Definition at line 67 of file error_counters.h.

## Constructor & Destructor Documentation

itpp::BERC::BERC | ( | int | indelay = `0`,
|  | int | inignorefirst = `0`,
|  | int | inignorelast = `0`
| ) |  |

Constructor for the berc class.

- delay is positive if in2 is a delayed replica of in1 and negative otherwise.
- ignorefirst and ignorelast may be used if errors in the begining and/or the end is to be ignored.

Definition at line 45 of file error_counters.cpp.

## Member Function Documentation

double itpp::BERC::count_errors | ( | const bvec & | in1,
|  | const bvec & | in2,
|  | int | indelay = `0`,
|  | int | inignorefirst = `0`,
|  | int | inignorelast = `0`
| ) |  |

static

static function to allow simple and fast count of bit-errors

Returns the number of errors between in1 and in2. Typical usage:

bvec in1 = randb(100);
bvec in2 = randb(100);
double errors = BERC::count_errors(in1, in2);

Definition at line 127 of file error_counters.cpp.

References itpp::abs(), and itpp::min().

The documentation for this class was generated from the following files:

- itpp/comm/error_counters.h
- itpp/comm/error_counters.cpp

Generated on Thu Mar 20 2014 12:26:46 for IT++ by Doxygen 1.8.6